//
//              LAPACK++ 1.1 Linear Algebra Package 1.1
//               University of Tennessee, Knoxvilee, TN.
//            Oak Ridge National Laboratory, Oak Ridge, TN.
//        Authors: J. J. Dongarra, E. Greaser, R. Pozo, D. Walker
//                 (C) 1992-1996 All Rights Reserved
//
//                             NOTICE
//
// Permission to use, copy, modify, and distribute this software and
// its documentation for any purpose and without fee is hereby granted
// provided that the above copyright notice appear in all copies and
// that both the copyright notice and this permission notice appear in
// supporting documentation.
//
// Neither the Institutions (University of Tennessee, and Oak Ridge National
// Laboratory) nor the Authors make any representations about the suitability 
// of this software for any purpose.  This software is provided ``as is'' 
// without express or implied warranty.
//
// LAPACK++ was funded in part by the U.S. Department of Energy, the
// National Science Foundation and the State of Tennessee.

#include "lafnames.h"
#include LA_VECTOR_DOUBLE_H

#ifdef length
#undef length
#endif

#ifdef append
#undef append
#endif

LaVectorDouble& LaVectorDouble::ref(SEXP x)
{				// create a reference to the data
    int n = LENGTH(x);
    LaVectorDouble tmp(REAL(coerceVector(x, REALSXP)), n);
    return ref(tmp);
}

SEXP LaVectorDouble::asSEXP() const
{
    SEXP val = allocVector(REALSXP, size());
    Memcpy(REAL(val), addr(), size());
    return val;
}
